Class cChildWindow Guid$("{a48a64eb-d92d-479a-ab26-f37a0153e1c5}") Common
	Instance hWnd_ As Dword
	Instance bridge_ As iMessageBridge

	Class Method Create()
	End Method

	Interface iMessage Guid$("{2e0e23cf-6e19-4a88-a33c-2cca8397778f}")
		Inherit IUnknown

		Property Get HWnd() As Long
			Property = hWnd_
		End Property

		Method Proc( ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long, ByRef ret As Long) As Long
			Method = -1: ' Default to handled, ret is already 0
			Select Case wMsg
				Case %WM_Char:
					If InStr("0123456789", Chr$(wparam))>0 Then Exit Method: ' Suppress numeric entry, ret=0
			End Select
			Method = 0: ' If we exit this way, we didn't handle message
		End Method
	End Interface

	Interface iChildWindow Guid$("{6856addd-9a21-440b-b360-4337b4cf182a}")
		Inherit IUnknown
		Method SetWindow( hParent As Dword, ByVal l As Long, ByVal t As Long, ByVal w As Long, ByVal h As Long )
			Dim vmsg As iMessage: ' This function belongs in the Create method, but PB doesn't support parameterized constructors

			hWnd_ = Me.CreateChildWindow( hParent, l, t, w, h ): ' Implementation Specific
			vmsg = Me
			bridge_ = NewMessageBridge( vmsg ): ' hWnd needs to be valid before this is called
		End Method
	End Interface

	' ========================================================
	' From here down is implementation specific stuff
	Class Method CreateChildWindow( hParent As Dword, ByVal l As Long, ByVal t As Long, ByVal w As Long, ByVal h As Long ) As Dword
		Static childId_ As Long
		Local vStyle As Dword

		' Get the next sequential child id
		childId_ = Min( 1000, (childId_ + 1) Mod 32767 )

		' Create the window
		vStyle = %WS_TabStop Or %WS_Border Or %WS_Child Or %WS_Visible
		Method = CreateWindowEx( 0, "EDIT", "Sample1", vStyle, l, t, w, h, hParent, childId_, GetModuleHandle( ByVal 0 ), ByVal 0 )
	End Method
End Class

Function NewChildWindow( hParent As Dword, ByVal l As Long, ByVal t As Long, ByVal w As Long, ByVal h As Long ) Common Export As iChildWindow
	Local obj As iChildWindow
	obj = Class "cChildWindow"
	obj.SetWindow( hParent, l, t, w, h )
	Function = obj
End Function
