#Compile Exe "TestBridge.exe"
#Dim All
#Compiler PBWin 10.03
#Register All

%INCLUDE=1
#Include Once "win32api.inc"
#If %Def( %INCLUDE )
#Include "Message.bas"
#Else
#Link "Message.sll"
#EndIf

#Include "ChildWindow.inc"

$TESTBRIDGE_CLASS = "lcTestBridge"

Function PBMain () As Long
	Local hTestBridge As Dword
	Local hChild As iChildWindow
	Local vStyle As Dword

	hTestBridge = TestBridge_CreateWindow()

	' Class processing (no numeric input)
	hChild = NewChildWindow( hTestBridge, 10, 10, 100, 23 )

	' Standard Edit BOX
	vStyle = %WS_TabStop Or %WS_Border Or %WS_Child Or %WS_Visible
	CreateWindowEx( 0, "EDIT", "Sample2", vStyle, 10, 43, 100, 23, hTestBridge, 101, GetModuleHandle( ByVal 0 ), ByVal 0 )

	ShowWindow( hTestBridge, %SW_ShowNormal )
	UpdateWindow( hTestBridge )

	Call TestBridge_Run( hTestBridge )
End Function

Function TestBridge_WndProc( ByVal hTestBridge As Dword, ByVal wMsg As Dword, ByVal wParam As Long, ByVal lParam As Long) As Long
	Function = 0
	Select Case As Const wMsg
		Case %WM_Activate:        Function = TestBridge_OnActivate( hTestBridge, wParam ): Exit Function
		Case %WM_SysColorChange:  Call TestBridge_OnSysColorChange( hTestBridge )
		Case %WM_EraseBkgnd:      Exit Function
		Case %WM_Destroy:         PostQuitMessage( 0 ): Exit Function
	End Select
	Function = DefWindowProc( hTestBridge, wMsg, wParam, lParam )
End Function

Function TestBridge_OnActivate( ByVal hTest As Dword, ByVal wParam As Long ) As Long
	Call SetAppActiveWindow( IIf&(wParam, hTest, 0 ) )
	Function = %MA_ACTIVATE
End Function

Sub TestBridge_OnSysColorChange( ByVal hTestBridge As Dword )
	Call EnumChildWindows( hTestBridge,  CodePtr( TestBridge_SysColorChange ), 0 ): ' Ensure child controls know of change
End Sub

Function TestBridge_SysColorChange( ByVal hWnd As Dword, ByVal lParam As Long ) As Long
	SendMessage( hWnd, %WM_SYSCOLORCHANGE, 0, 0 )
	Function = %TRUE: ' Continue enumeration
End Function

Sub TestBridge_RegisterClasses()
	Local wc As WNDCLASSEX
	Local className As StringZ*20
	Static gInit As Long

	If gInit Then Exit Sub: ' Already registered
	gInit = -1
	If GetClassInfoEx(%NULL, $TESTBRIDGE_CLASS, wc) Then Exit Sub: ' Already registered (another app)

	' Register class for Overlapped window
	className = $TESTBRIDGE_CLASS
	wc.cbsize = SizeOf(wc)
	wc.style = %CS_HREDRAW Or %CS_VREDRAW
	wc.lpfnWndProc = CodePtr( TestBridge_WndProc )
	wc.cbClsExtra = 0
	wc.cbWndExtra = 0: ' No window data
	wc.hInstance = GetModuleHandle( ByVal 0 )
	wc.hIcon = LoadIcon( ByVal %NULL, ByVal %IDI_APPLICATION )
	wc.hCursor = LoadCursor(%NULL, ByVal %IDC_ARROW)
	wc.hbrBackground = %COLOR_3DFACE+1
	wc.lpszMenuName =  0
	wc.lpszClassName = VarPtr(className)
	If RegisterClassEx( wc )=0 Then
		MsgBox "RegisterClass for TestBridge failed"
		End
	End If
End Sub

Function TestBridge_CreateWindow() Common As Dword
	Local hTestBridge As Dword

	Call TestBridge_RegisterClasses()
	hTestBridge = CreateWindowEx( 0, $TESTBRIDGE_CLASS, "Test Bridge", %WS_OverlappedWindow Or %WS_ClipChildren, %CW_USEDEFAULT, %CW_USEDEFAULT, %CW_USEDEFAULT, %CW_USEDEFAULT, %NULL, %NULL, GetModuleHandle( ByVal 0 ), ByVal 0 )
	Function = hTestBridge
End Function

Global hawnd As Dword
Sub SetAppActiveWindow( ByVal hWnd As Dword )
	hawnd = hWnd
End Sub

Function TestBridge_Run(ByVal hTestBridge As Long) As Long
	Local msg As tagMSG

	Do While GetMessage( msg, %NULL, 0, 0 )>0
		If hawnd=0 Or IsDialogMessage( hawnd, msg ) = 0 Then
				TranslateMessage( msg )
				DispatchMessage( msg )
		End If
	Loop
End Function
